All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
5 mr - a Multiple Repository management tool
9 B<mr> [options] checkout
11 B<mr> [options] update
13 B<mr> [options] status
15 B<mr> [options] commit [-m "message"]
17 B<mr> [options] record [-m "message"]
25 B<mr> [options] run command [param ...]
27 B<mr> [options] bootstrap url [directory]
29 B<mr> [options] register [repository]
31 B<mr> [options] config section ["parameter=[value]" ...]
33 B<mr> [options] action [params ...]
35 B<mr> [options] [online|offline]
37 B<mr> [options] remember action [params ...]
41 B<mr> is a Multiple Repository management tool. It can checkout, update, or
42 perform other actions on a set of repositories as if they were one combined
43 repository. It supports any combination of subversion, git, cvs, mercurial,
44 bzr, darcs, fossil and veracity repositories, and support for other version
45 control systems can easily be added.
47 B<mr> cds into and operates on all registered repositories at or below your
48 working directory. Or, if you are in a subdirectory of a repository that
49 contains no other registered repositories, it will stay in that directory,
50 and work on only that repository,
52 B<mr> is configured by .mrconfig files, which list the repositories. It
53 starts by reading the .mrconfig file in your home directory, and this can
54 in turn chain load .mrconfig files from repositories. It also automatically
55 looks for a .mrconfig file in the current directory, or in one of its
58 These predefined commands should be fairly familiar to users of any version
63 =item checkout (or co)
65 Checks out any repositories that are not already checked out.
69 Updates each repository from its configured remote repository.
71 If a repository isn't checked out yet, it will first check it out.
75 Displays a status report for each repository, showing what
76 uncommitted changes are present in the repository.
80 Commits changes to each repository. (By default, changes are pushed to the
81 remote repository too, when using distributed systems like git. If you
82 don't like this default, you can change it in your .mrconfig, or use record
85 The optional -m parameter allows specifying a commit message.
89 Records changes to the local repository, but does not push them to the
90 remote repository. Only supported for distributed version control systems.
92 The optional -m parameter allows specifying a commit message.
96 Pushes committed local changes to the remote repository. A no-op for
97 centralized version control systems.
101 Show a diff of uncommitted changes.
107 =item run command [param ...]
109 Runs the specified command in each repository.
113 These commands are also available:
117 =item bootstrap url [directory]
119 Causes mr to download the url, and use it as a .mrconfig file
120 to checkout the repositories listed in it, into the specified directory.
122 The directory will be created if it does not exist. If no directory is
123 specified, the current directory will be used.
125 If the .mrconfig file includes a repository named ".", that
126 is checked out into the top of the specified directory.
130 List the repositories that mr will act on.
134 Register an existing repository in a mrconfig file. By default, the
135 repository in the current directory is registered, or you can specify a
136 directory to register.
138 The mrconfig file that is modified is chosen by either the -c option, or by
139 looking for the closest known one at or in a parent of the current directory.
143 Adds, modifies, removes, or prints a value from a mrconfig file. The next
144 parameter is the name of the section the value is in. To add or modify
145 values, use one or more instances of "parameter=value". Use "parameter=" to
146 remove a parameter. Use just "parameter" to get the value of a parameter.
148 For example, to add (or edit) a repository in src/foo:
150 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
152 To show the command that mr uses to update the repository in src/foo:
154 mr config src/foo update
156 To see the built-in library of shell functions contained in mr:
158 mr config DEFAULT lib
160 The mrconfig file that is used is chosen by either the -c option, or by
161 looking for the closest known one at or in a parent of the current directory.
165 Advises mr that it is in offline mode. Any commands that fail in
166 offline mode will be remembered, and retried when mr is told it's online.
170 Advices mr that it is in online mode again. Commands that failed while in
171 offline mode will be re-run.
175 Remember a command, to be run later when mr re-enters online mode. This
176 implicitly puts mr into offline mode. The command can be any regular mr
177 command. This is useful when you know that a command will fail due to being
178 offline, and so don't want to run it right now at all, but just remember
179 to run it when you go back online.
187 Actions can be abbreviated to any unambiguous substring, so
188 "mr st" is equivalent to "mr status", and "mr up" is equivalent to "mr
191 Additional parameters can be passed to most commands, and are passed on
192 unchanged to the underlying version control system. This is mostly useful
193 if the repositories mr will act on all use the same version control
202 =item --directory directory
204 Specifies the topmost directory that B<mr> should work in. The default is
205 the current working directory.
209 =item --config mrconfig
211 Use the specified mrconfig file. The default is to use both F<~/.mrconfig>
212 as well as look for a F<.mrconfig> file in the current directory, or in one
213 of its parent directories.
219 Force mr to act on repositories that would normally be skipped due to their
232 Be quiet. This suppresses mr's usual output, as well as any output from
233 commands that are run (including stderr output). If a command fails,
234 the output will be shown.
240 Accept untrusted SSL certificates when bootstrapping.
246 Expand the statistics line displayed at the end to include information
247 about exactly which repositories failed and were skipped, if any.
253 Interactive mode. If a repository fails to be processed, a subshell will be
254 started which you can use to resolve or investigate the problem. Exit the
255 subshell to continue the mr run.
259 =item --no-recurse [number]
261 If no number if specified, just operate on the repository for the current
262 directory, do not recurse into deeper repositories.
264 If a number is specified, will recurse into repositories at most that many
265 subdirectories deep. For example, with -n 2 it would recurse into ./src/foo,
266 but not ./src/packages/bar.
270 =item --jobs [number]
272 Run the specified number of jobs in parallel, or an unlimited number of jobs
273 with no number specified. This can greatly speed up operations such as updates.
274 It is not recommended for interactive operations.
276 Note that running more than 10 jobs at a time is likely to run afoul of
277 ssh connection limits. Running between 3 and 5 jobs at a time will yield
278 a good speedup in updates without loading the machine too much.
284 Trust all mrconfig files even if they are not listed in F<~/.mrtrust>.
291 This obsolete flag is ignored.
295 =head1 MRCONFIG FILES
297 Here is an example F<.mrconfig> file:
300 checkout = svn checkout svn://svn.example.com/src/trunk src
304 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
306 git checkout -b mybranch origin/master
308 The F<.mrconfig> file uses a variant of the INI file format. Lines
309 starting with "#" are comments. Values can be continued to the
310 following line by indenting the line with whitespace.
312 The C<DEFAULT> section allows setting default values for the sections that
315 The C<ALIAS> section allows adding aliases for actions. Each parameter
316 is an alias, and its value is the action to use.
318 All other sections add repositories. The section header specifies the
319 directory where the repository is located. This is relative to the directory
320 that contains the mrconfig file, but you can also choose to use absolute
321 paths. (Note that you can use environment variables in section names; they
322 will be passed through the shell for expansion. For example,
323 C<[$HOSTNAME]>, or C<[${HOSTNAME}foo]>).
325 Within a section, each parameter defines a shell command to run to handle a
326 given action. mr contains default handlers for "update", "status",
327 "commit", and other standard actions.
329 Normally you only need to specify what to do for "checkout". Here you
330 specify the command to run in order to create a checkout of the repository.
331 The command will be run in the parent directory, and must create the
332 repository's directory. So use C<git clone>, C<svn checkout>, C<bzr branch>
333 or C<bzr checkout> (for a bound branch), etc.
335 Note that these shell commands are run in a C<set -e> shell
336 environment, where any additional parameters you pass are available in
337 C<$@>. All commands other than "checkout" are run inside the repository,
338 though not necessarily at the top of it.
340 The C<MR_REPO> environment variable is set to the path to the top of the
341 repository. (For the "register" action, "MR_REPO" is instead set to the
342 basename of the directory that should be created when checking the
345 The C<MR_CONFIG> environment variable is set to the .mrconfig file
346 that defines the repo being acted on, or, if the repo is not yet in a config
347 file, the F<.mrconfig> file that should be modified to register the repo.
349 The C<MR_ACTION> environment variable is set to the command being run
350 (update, checkout, etc).
352 A few parameters have special meanings:
358 If the "skip" parameter is set and its command returns true, then B<mr>
359 will skip acting on that repository. The command is passed the action
362 Here are two examples. The first skips the repo unless
363 mr is run by joey. The second uses the hours_since function
364 (included in mr's built-in library) to skip updating the repo unless it's
365 been at least 12 hours since the last update.
369 skip = test `whoami` != joey
373 skip = [ "$1" = update ] && ! hours_since "$1" 12
375 Another way to use skip is for a lazy checkout. This makes mr skip
376 operating on a repo unless it already exists. To enable the
377 repo, you have to explicitly check it out (using "mr --force -d foo checkout").
385 The "order" parameter can be used to override the default ordering of
386 repositories. The default order value is 10. Use smaller values to make
387 repositories be processed earlier, and larger values to make repositories
390 Note that if a repository is located in a subdirectory of another
391 repository, ordering it to be processed earlier is not recommended.
395 If the "chain" parameter is set and its command returns true, then B<mr>
396 will try to load a F<.mrconfig> file from the root of the repository.
400 If the "include" parameter is set, its command is ran, and should output
401 additional mrconfig file content. The content is included as if it were
402 part of the including file.
404 Unlike all other parameters, this parameter does not need to be placed
407 B<mr> ships several libraries that can be included to add support for
408 additional version control type things (unison, git-svn, vcsh, git-fake-bare,
409 git-subtree). To include them all, you could use:
411 include = cat /usr/share/mr/*
413 See the individual files for details.
417 If the "deleted" parameter is set and its command returns true, then
418 B<mr> will treat the repository as deleted. It won't ever actually delete
419 the repository, but it will warn if it sees the repository's directory.
420 This is useful when one mrconfig file is shared among multiple machines,
421 to keep track of and remember to delete old repositories.
425 The "lib" parameter can specify some shell code that will be run
426 before each command, this can be a useful way to define shell
427 functions for other commands to use.
429 Unlike most other parameters, this can be specified multiple times, in
430 which case the chunks of shell code are accumulatively concatenated
435 If the "fixups" parameter is set, its command is run whenever a repository
436 is checked out, or updated. This provides an easy way to do things
437 like permissions fixups, or other tweaks to the repository content,
438 whenever the repository is changed.
442 When looking for a command to run for a given action, mr first looks for
443 a parameter with the same name as the action. If that is not found, it
444 looks for a parameter named "VCS_action" (substituting in the name of the
445 version control system and the action).
447 Internally, mr has settings for "git_update", "svn_update", etc. To change
448 the action that is performed for a given version control system, you can
449 override these VCS specific actions. To add a new version control system,
450 you can just add VCS specific actions for it.
454 If a "pre_action" parameter is set, its command is run before mr performs the
455 specified action. Similarly, "post_action" parameters are run after mr
456 successfully performs the specified action. For example, "pre_commit" is
457 run before committing; "post_update" is run after updating.
461 Any parameter can be suffixed with C<_append>, to add an additional value
462 to the existing value of the parameter. In this way, actions
463 can be constructed accumulatively.
467 The name of the version control system is itself determined by
468 running each defined "VCS_test" action, until one succeeds.
472 =head1 UNTRUSTED MRCONFIG FILES
474 Since mrconfig files can contain arbitrary shell commands, they can do
475 anything. This flexibility is good, but it also allows a malicious mrconfig
476 file to delete your whole home directory. Such a file might be contained
477 inside a repository that your main F<~/.mrconfig> checks out. To
478 avoid worries about evil commands in a mrconfig file, mr defaults to
479 reading all mrconfig files other than the main F<~/.mrconfig> in untrusted
480 mode. In untrusted mode, mrconfig files are limited to running only known
481 safe commands (like "git clone") in a carefully checked manner.
483 To configure mr to trust other mrconfig files, list them in F<~/.mrtrust>.
484 One mrconfig file should be listed per line. Either the full pathname
485 should be listed, or the pathname can start with F<~/> to specify a file
486 relative to your home directory.
488 =head1 OFFLINE LOG FILE
490 The F<~/.mrlog> file contains commands that mr has remembered to run later,
491 due to being offline. You can delete or edit this file to remove commands,
492 or even to add other commands for 'mr online' to run. If the file is
493 present, mr assumes it is in offline mode.
497 mr can be extended to support things such as unison and git-svn. Some
498 files providing such extensions are available in F</usr/share/mr/>. See
499 the documentation in the files for details about using them.
503 mr returns nonzero if a command failed in any of the repositories.
507 Copyright 2007-2011 Joey Hess <joey@kitenet.net>
509 Licensed under the GNU GPL version 2 or higher.
511 http://kitenet.net/~joey/code/mr/
518 use Cwd qw(getcwd abs_path);
520 # things that can happen when mr runs a command
529 my $config_overridden=0;
540 my $directory=getcwd();
542 my $HOME_MR_CONFIG = "$ENV{HOME}/.mrconfig";
543 $ENV{MR_CONFIG}=find_mrconfig();
550 my (@ok, @failed, @skipped);
560 # Runs a shell command using a supplied function.
561 # The lib will be included in the shell command line, and any params
562 # will be available in the shell as $1, $2, etc.
565 my ($action, $topdir, $subdir, $command, $params, $runner) = @_;
567 # optimisation: avoid running the shell for true and false
568 if ($command =~ /^\s*true\s*$/) {
572 elsif ($command =~ /^\s*false\s*$/) {
577 my $quotedparams=join(" ", (map { shellquote($_) } @$params));
578 my $lib=exists $config{$topdir}{$subdir}{lib} ?
579 $config{$topdir}{$subdir}{lib}."\n" : "";
580 if ($verbose && (! defined $lastlib || $lastlib ne $lib)) {
581 print "mr library now: >>$lib<<\n";
584 my $shellcode="set -e;".$lib.
585 "my_sh(){ $command\n }; my_sh $quotedparams";
586 print "mr $action: running $action >>$command<<\n" if $verbose;
587 $runner->($shellcode);
594 if ($s =~ m/^perl:\s+(.*)/s) {
595 return $perl_cache{$1} if exists $perl_cache{$1};
596 my $sub=eval "sub {$1}";
597 if (! defined $sub) {
598 print STDERR "mr: bad perl code in $id: $@\n";
600 return $perl_cache{$1} = $sub;
607 my ($action, $dir, $topdir, $subdir) = @_;
609 if (exists $vcs{$dir}) {
615 foreach my $vcs_test (
617 length $a <=> length $b
620 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
621 my ($vcs)=$vcs_test =~ /(.*)_test/;
622 my $p=perl($vcs_test, $config{$topdir}{$subdir}{$vcs_test});
627 $test="my_$vcs_test() {\n$config{$topdir}{$subdir}{$vcs_test}\n}\n".$test;
628 $test.="if my_$vcs_test; then echo $vcs; fi\n";
633 foreach my $vcs (keys %perltest) {
634 if ($perltest{$vcs}->()) {
639 push @vcs, split(/\n/,
640 runsh("vcs test", $topdir, $subdir, $test, [], sub {
646 print STDERR "mr $action: found multiple possible repository types (@vcs) for ".fulldir($topdir, $subdir)."\n";
650 return $vcs{$dir}=undef;
653 return $vcs{$dir}=$vcs[0];
658 my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
660 if (exists $config{$topdir}{$subdir}{$action}) {
661 return $config{$topdir}{$subdir}{$action};
668 my $vcs=vcs_test(@_);
671 exists $config{$topdir}{$subdir}{$vcs."_".$action}) {
672 return $config{$topdir}{$subdir}{$vcs."_".$action};
680 my ($topdir, $subdir) = @_;
681 return $subdir =~ /^\// ? $subdir : $topdir.$subdir;
685 my ($action, $dir, $topdir, $subdir, $force_checkout) = @_;
686 my $fulldir=fulldir($topdir, $subdir);
688 $ENV{MR_CONFIG}=$configfiles{$topdir};
689 my $is_checkout=($action eq 'checkout');
690 my $is_update=($action =~ /update/);
692 ($ENV{MR_REPO}=$dir) =~ s!/$!!;
693 $ENV{MR_ACTION}=$action;
695 foreach my $testname ("skip", "deleted") {
696 next if $force && $testname eq "skip";
698 my $testcommand=findcommand($testname, $dir, $topdir, $subdir, $is_checkout);
700 if (defined $testcommand) {
701 my $ret=runsh "$testname test", $topdir, $subdir,
702 $testcommand, [$action],
703 sub { system(shift()) };
705 if (($? & 127) == 2) {
706 print STDERR "mr $action: interrupted\n";
710 print STDERR "mr $action: $testname test received signal ".($? & 127)."\n";
714 if ($ret >> 8 == 0) {
715 if ($testname eq "deleted") {
717 print STDERR "mr error: $dir should be deleted yet still exists\n";
721 print "mr $action: skip $dir skipped\n" if $verbose;
728 if (! $force_checkout) {
730 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
734 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
739 return action("checkout", $dir, $topdir, $subdir);
743 my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
745 if ($is_checkout && ! -d $dir) {
746 print "mr $action: creating parent directory $dir\n" if $verbose;
747 system("mkdir", "-p", $dir);
750 if (! $no_chdir && ! chdir($dir)) {
751 print STDERR "mr $action: failed to chdir to $dir: $!\n";
754 elsif (! defined $command) {
755 my $vcs=vcs_test(@_);
756 if (! defined $vcs) {
757 print STDERR "mr $action: unknown repository type and no defined $action command for $fulldir\n";
761 print STDERR "mr $action: no defined action for $vcs repository $fulldir, skipping\n";
768 $actionmsg="mr $action: $fulldir";
772 $s=~s/^\Q$fulldir\E\/?//;
773 $actionmsg="mr $action: $fulldir (in subdir $s)";
775 print "$actionmsg\n" unless $quiet;
777 my $hookret=hook("pre_$action", $topdir, $subdir);
778 return $hookret if $hookret != OK;
780 my $ret=runsh $action, $topdir, $subdir,
781 $command, \@ARGV, sub {
784 my $output = qx/$sh 2>&1/;
787 print "$actionmsg\n";
788 print STDERR $output;
797 if (($? & 127) == 2) {
798 print STDERR "mr $action: interrupted\n";
802 print STDERR "mr $action: received signal ".($? & 127)."\n";
805 print STDERR "mr $action: failed ($ret)\n" if $verbose;
806 if ($ret >> 8 != 0) {
807 print STDERR "mr $action: command failed\n";
808 if (-e "$ENV{HOME}/.mrlog" && $action ne 'remember') {
809 # recreate original command line to
810 # remember, and avoid recursing
812 @ARGV=('-n', $action, @orig);
813 action("remember", $dir, $topdir, $subdir);
818 print STDERR "mr $action: command died ($ret)\n";
823 if ($is_checkout && ! -d $dir) {
824 print STDERR "mr $action: $dir missing after checkout\n";;
828 my $ret=hook("post_$action", $topdir, $subdir);
829 return $ret if $ret != OK;
831 if (($is_checkout || $is_update)) {
832 my $ret=hook("fixups", $topdir, $subdir);
833 return $ret if $ret != OK;
842 my ($hook, $topdir, $subdir) = @_;
844 my $command=$config{$topdir}{$subdir}{$hook};
845 return OK unless defined $command;
846 my $ret=runsh $hook, $topdir, $subdir, $command, [], sub {
849 my $output = qx/$sh 2>&1/;
852 print STDERR $output;
861 if (($? & 127) == 2) {
862 print STDERR "mr $hook: interrupted\n";
866 print STDERR "mr $hook: received signal ".($? & 127)."\n";
877 # run actions on multiple repos, in parallel
887 while (@fhs or @repos) {
888 while ((!$jobs || $running < $jobs) && @repos) {
890 my $repo = shift @repos;
891 pipe(my $outfh, CHILD_STDOUT);
892 pipe(my $errfh, CHILD_STDERR);
894 unless ($pid = fork) {
895 die "mr $action: cannot fork: $!" unless defined $pid;
896 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
897 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
902 exit action($action, @$repo);
906 push @active, [$pid, $repo];
907 push @fhs, [$outfh, $errfh];
910 my ($rin, $rout) = ('','');
912 foreach my $fh (@fhs) {
913 next unless defined $fh;
914 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
915 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
917 $nfound = select($rout=$rin, undef, undef, 1);
918 foreach my $channel (0, 1) {
919 foreach my $i (0..$#fhs) {
920 next unless defined $fhs[$i];
921 my $fh = $fhs[$i][$channel];
922 next unless defined $fh;
923 if (vec($rout, fileno($fh), 1) == 1) {
925 if (sysread($fh, $r, 1024) == 0) {
927 $fhs[$i][$channel] = undef;
928 if (! defined $fhs[$i][0] &&
929 ! defined $fhs[$i][1]) {
930 waitpid($active[$i][0], 0);
931 print STDOUT $out[$i][0];
932 print STDERR $out[$i][1];
933 record($active[$i][1], $? >> 8);
935 splice(@active, $i, 1);
940 $out[$i][$channel] .= $r;
948 my $dir=shift()->[0];
953 print "\n" unless $quiet;
955 elsif ($ret == FAILED) {
957 chdir($dir) unless $no_chdir;
958 print STDERR "mr: Starting interactive shell. Exit shell to continue.\n";
959 system((getpwuid($<))[8], "-i");
962 print "\n" unless $quiet;
964 elsif ($ret == SKIPPED) {
967 elsif ($ret == ABORT) {
971 die "unknown exit status $ret";
977 if (! @ok && ! @failed && ! @skipped) {
978 die "mr $action: no repositories found to work on\n";
980 print "mr $action: finished (".join("; ",
981 showstat($#ok+1, "ok", "ok"),
982 showstat($#failed+1, "failed", "failed"),
983 showstat($#skipped+1, "skipped", "skipped"),
984 ).")\n" unless $quiet;
987 print "mr $action: (skipped: ".join(" ", @skipped).")\n" unless $quiet;
990 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
1000 return "$count ".($count > 1 ? $plural : $singular);
1005 # an ordered list of repos
1008 foreach my $topdir (sort keys %config) {
1009 foreach my $subdir (sort keys %{$config{$topdir}}) {
1013 order => $config{$topdir}{$subdir}{order},
1018 $a->{order} <=> $b->{order}
1020 $a->{topdir} cmp $b->{topdir}
1022 $a->{subdir} cmp $b->{subdir}
1028 my $topdir=$repo->{topdir};
1029 my $subdir=$repo->{subdir};
1030 my $ret=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
1035 # Figure out which repos to act on. Returns a list of array refs
1038 # [ "$full_repo_path/", "$mr_config_path/", $section_header ]
1041 foreach my $repo (repolist()) {
1042 my $topdir=$repo->{topdir};
1043 my $subdir=$repo->{subdir};
1045 next if $subdir eq 'DEFAULT';
1046 my $dir=repodir($repo);
1048 $dir.="/" unless $dir=~/\/$/;
1049 $d.="/" unless $d=~/\/$/;
1050 next if $dir ne $d && $dir !~ /^\Q$d\E/;
1051 if (defined $max_depth) {
1052 my @a=split('/', $dir);
1053 my @b=split('/', $d);
1054 do { } while (@a && @b && shift(@a) eq shift(@b));
1055 next if @a > $max_depth || @b > $max_depth;
1057 push @repos, [$dir, $topdir, $subdir];
1060 # fallback to find a leaf repo
1061 foreach my $repo (reverse repolist()) {
1062 my $topdir=$repo->{topdir};
1063 my $subdir=$repo->{subdir};
1065 next if $subdir eq 'DEFAULT';
1066 my $dir=repodir($repo);
1068 $dir.="/" unless $dir=~/\/$/;
1069 $d.="/" unless $d=~/\/$/;
1070 if ($d=~/^\Q$dir\E/) {
1071 push @repos, [$dir, $topdir, $subdir];
1093 sub is_trusted_config {
1094 my $config=shift; # must be abs_pathed already
1096 # We always trust ~/.mrconfig.
1097 return 1 if $config eq abs_path($HOME_MR_CONFIG);
1099 return 1 if $trust_all;
1101 my $trustfile=$ENV{HOME}."/.mrtrust";
1104 $trusted{$HOME_MR_CONFIG}=1;
1105 if (open (TRUST, "<", $trustfile)) {
1108 s/^~\//$ENV{HOME}\//;
1109 $trusted{abs_path($_)}=1;
1115 return $trusted{$config};
1119 sub is_trusted_repo {
1122 # Tightly limit what is allowed in a repo name.
1123 # No ../, no absolute paths, and no unusual filenames
1124 # that might try to escape to the shell.
1125 return $repo =~ /^[-_.+\/A-Za-z0-9]+$/ &&
1126 $repo !~ /\.\./ && $repo !~ /^\//;
1129 sub is_trusted_checkout {
1132 # To determine if the command is safe, compare it with the
1133 # *_trusted_checkout config settings. Those settings are
1134 # templates for allowed commands, so make sure that each word
1135 # of the command matches the corresponding word of the template.
1138 foreach my $word (split(' ', $command)) {
1140 if ($word=~/^'(.*)'$/) {
1143 elsif ($word=~/^"(.*)"$/) {
1150 foreach my $key (grep { /_trusted_checkout$/ }
1151 keys %{$config{''}{DEFAULT}}) {
1152 my @twords=split(' ', $config{''}{DEFAULT}{$key});
1153 next if @words > @twords;
1157 for (my $c=0; $c < @twords && $match; $c++) {
1158 if ($twords[$c] eq '$url') {
1159 # Match all the typical characters found in
1160 # urls, plus @ which svn can use. Note
1161 # that the "url" might also be a local
1164 defined $words[$c] &&
1165 $words[$c] =~ /^[-_.+:@\/A-Za-z0-9]+$/
1169 elsif ($twords[$c] eq '$repo') {
1170 # If a repo is not specified, assume it
1171 # will be the last path component of the
1172 # url, or something derived from it, and
1174 if (! defined $words[$c] && defined $url) {
1175 ($words[$c])=$url=~/\/([^\/]+)\/?$/;
1179 defined $words[$c] &&
1180 is_trusted_repo($words[$c])
1183 elsif (defined $words[$c] && $words[$c]=~/^($twords[$c])$/) {
1200 my $bootstrap_url=shift;
1206 if (ref $f eq 'GLOB') {
1212 my $absf=abs_path($f);
1213 if ($loaded{$absf}) {
1218 $trusted=is_trusted_config($absf);
1220 if (! defined $dir) {
1221 ($dir)=$f=~/^(.*\/)[^\/]+$/;
1222 if (! defined $dir) {
1227 $dir=abs_path($dir)."/";
1229 if (! exists $configfiles{$dir}) {
1230 $configfiles{$dir}=$f;
1233 # copy in defaults from first parent
1235 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
1236 if ($parent eq '/') {
1239 if (exists $config{$parent} &&
1240 exists $config{$parent}{DEFAULT}) {
1241 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
1250 print "mr: loading config $f\n" if $verbose;
1251 open($in, "<", $f) || die "mr: open $f: $!\n";
1254 close $in unless ref $f eq 'GLOB';
1258 # Keep track of the current line in the config file;
1259 # when a file is included track the current line from the include.
1264 my $nextline = sub {
1276 my $lineerror = sub {
1278 if (defined $included) {
1279 die "mr: $msg at $f line $lineno, included line: $line\n";
1282 die "mr: $msg at $f line $lineno\n";
1285 my $trusterror = sub {
1288 if (defined $bootstrap_url) {
1289 die "mr: $msg in untrusted $bootstrap_url line $lineno\n".
1290 "(To trust this url, --trust-all can be used; but please use caution;\n".
1291 "this can allow arbitrary code execution!)\n";
1294 die "mr: $msg in untrusted $f line $lineno\n".
1295 "(To trust this file, list it in ~/.mrtrust.)\n";
1302 if (! $trusted && /[[:cntrl:]]/) {
1303 $trusterror->("illegal control character");
1306 next if /^\s*\#/ || /^\s*$/;
1307 if (/^\[([^\]]*)\]\s*$/) {
1311 if (! is_trusted_repo($section) ||
1312 $section eq 'ALIAS' ||
1313 $section eq 'DEFAULT') {
1314 $trusterror->("illegal section \"[$section]\"");
1317 $section=expandenv($section) if $trusted;
1318 if ($section ne 'ALIAS' &&
1319 ! exists $config{$dir}{$section} &&
1320 exists $config{$dir}{DEFAULT}) {
1322 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
1325 elsif (/^(\w+)\s*=\s*(.*)/) {
1330 while (@lines && $lines[0]=~/^\s(.+)/) {
1337 # Untrusted files can only contain a few
1338 # settings in specific known-safe formats.
1339 if ($parameter eq 'checkout') {
1340 if (! is_trusted_checkout($value)) {
1341 $trusterror->("illegal checkout command \"$value\"");
1344 elsif ($parameter eq 'order') {
1345 # not interpreted as a command, so
1348 elsif ($value eq 'true' || $value eq 'false') {
1349 # skip=true , deleted=true etc are
1353 $trusterror->("illegal setting \"$parameter=$value\"");
1357 if ($parameter eq "include") {
1358 print "mr: including output of \"$value\"\n" if $verbose;
1361 print STDERR "mr: include command exited nonzero ($?)\n";
1364 unshift @lines, @inc;
1368 if (! defined $section) {
1369 $lineerror->("parameter ($parameter) not in section");
1371 if ($section eq 'ALIAS') {
1372 $alias{$parameter}=$value;
1374 elsif ($parameter eq 'lib' or $parameter =~ s/_append$//) {
1375 $config{$dir}{$section}{$parameter}.="\n".$value."\n";
1378 $config{$dir}{$section}{$parameter}=$value;
1379 if ($parameter =~ /.*_(.*)/) {
1380 $knownactions{$1}=1;
1383 $knownactions{$parameter}=1;
1385 if ($parameter eq 'chain' &&
1386 length $dir && $section ne "DEFAULT") {
1387 my $chaindir="$section";
1388 if ($chaindir !~ m!^/!) {
1389 $chaindir=$dir.$chaindir;
1391 if (-e "$chaindir/.mrconfig") {
1392 my $ret=system($value);
1394 if (($? & 127) == 2) {
1395 print STDERR "mr: chain test interrupted\n";
1399 print STDERR "mr: chain test received signal ".($? & 127)."\n";
1403 push @toload, ["$chaindir/.mrconfig", $chaindir];
1410 $lineerror->("parse error");
1414 foreach my $c (@toload) {
1419 sub startingconfig {
1420 %alias=%config=%configfiles=%knownactions=%loaded=();
1421 my $datapos=tell(DATA);
1423 seek(DATA,$datapos,0); # rewind
1428 # the section to modify or add
1429 my $targetsection=shift;
1430 # fields to change in the section
1431 # To remove a field, set its value to "".
1432 my %changefields=@_;
1438 open(my $in, "<", $f) || die "mr: open $f: $!\n";
1443 my $formatfield=sub {
1445 my @value=split(/\n/, shift);
1447 return "$field = ".shift(@value)."\n".
1448 join("", map { "\t$_\n" } @value);
1452 while ($out[$#out] =~ /^\s*$/) {
1453 unshift @blanks, pop @out;
1455 foreach my $field (sort keys %changefields) {
1456 if (length $changefields{$field}) {
1457 push @out, "$field = $changefields{$field}\n";
1458 delete $changefields{$field};
1468 if (/^\s*\#/ || /^\s*$/) {
1471 elsif (/^\[([^\]]*)\]\s*$/) {
1472 if (defined $section &&
1473 $section eq $targetsection) {
1477 $section=expandenv($1);
1481 elsif (/^(\w+)\s*=\s(.*)/) {
1486 while (@lines && $lines[0]=~/^\s(.+)/) {
1492 if ($section eq $targetsection) {
1493 if (exists $changefields{$parameter}) {
1494 if (length $changefields{$parameter}) {
1495 $value=$changefields{$parameter};
1497 delete $changefields{$parameter};
1501 push @out, $formatfield->($parameter, $value);
1505 if (defined $section &&
1506 $section eq $targetsection) {
1509 elsif (%changefields) {
1510 push @out, "\n[$targetsection]\n";
1511 foreach my $field (sort keys %changefields) {
1512 if (length $changefields{$field}) {
1513 push @out, $formatfield->($field, $changefields{$field});
1518 open(my $out, ">", $f) || die "mr: write $f: $!\n";
1526 # actions that do not operate on all repos
1527 if ($action eq 'help') {
1530 elsif ($action eq 'config') {
1533 elsif ($action eq 'register') {
1536 elsif ($action eq 'bootstrap') {
1539 elsif ($action eq 'remember' ||
1540 $action eq 'offline' ||
1541 $action eq 'online') {
1542 my @repos=selectrepos;
1543 action($action, @{$repos[0]}) if @repos;
1547 if (!$jobs || $jobs > 1) {
1548 mrs($action, selectrepos());
1551 foreach my $repo (selectrepos()) {
1552 record($repo, action($action, @$repo));
1558 exec($config{''}{DEFAULT}{help}) || die "exec: $!";
1563 die "mr config: not enough parameters\n";
1566 if ($section=~/^\//) {
1567 # try to convert to a path relative to the config file
1568 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
1569 $dir=abs_path($dir);
1570 $dir.="/" unless $dir=~/\/$/;
1571 if ($section=~/^\Q$dir\E(.*)/) {
1577 if (/^([^=]+)=(.*)$/) {
1578 $changefields{$1}=$2;
1582 foreach my $topdir (sort keys %config) {
1583 if (exists $config{$topdir}{$section} &&
1584 exists $config{$topdir}{$section}{$_}) {
1585 print $config{$topdir}{$section}{$_}."\n";
1587 last if $section eq 'DEFAULT';
1591 die "mr config: $section $_ not set\n";
1595 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
1600 if ($config_overridden) {
1601 # Find the directory that the specified config file is
1603 ($directory)=abs_path($ENV{MR_CONFIG})=~/^(.*\/)[^\/]+$/;
1606 # Find the closest known mrconfig file to the current
1608 $directory.="/" unless $directory=~/\/$/;
1610 foreach my $topdir (reverse sort keys %config) {
1611 next unless length $topdir;
1612 if ($directory=~/^\Q$topdir\E/) {
1613 $ENV{MR_CONFIG}=$configfiles{$topdir};
1619 if (! $foundconfig) {
1620 $directory=""; # no config file, use builtin
1624 my $subdir=shift @ARGV;
1625 if (! chdir($subdir)) {
1626 print STDERR "mr register: failed to chdir to $subdir: $!\n";
1630 $ENV{MR_REPO}=getcwd();
1631 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
1632 if (! defined $command) {
1633 die "mr register: unknown repository type\n";
1636 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1637 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1638 "my_action(){ $command\n }; my_action ".
1639 join(" ", map { s/\\/\\\\/g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1640 print "mr register: running >>$command<<\n" if $verbose;
1641 exec($command) || die "exec: $!";
1645 my $url=shift @ARGV;
1646 my $dir=shift @ARGV || ".";
1648 if (! defined $url || ! length $url) {
1649 die "mr: bootstrap requires url\n";
1652 # Download the config file to a temporary location.
1653 eval q{use File::Temp};
1655 my $tmpconfig=File::Temp->new();
1656 my @curlargs = ("curl", "-A", "mr", "-L", "-s", $url, "-o", $tmpconfig);
1657 push(@curlargs, "-k") if $insecure;
1658 my $curlstatus = system(@curlargs);
1659 die "mr bootstrap: invalid SSL certificate for $url (consider -k)\n" if $curlstatus >> 8 == 60;
1660 die "mr bootstrap: download of $url failed\n" if $curlstatus != 0;
1663 system("mkdir", "-p", $dir);
1665 chdir($dir) || die "chdir $dir: $!";
1667 # Special case to handle checkout of the "." repo, which
1668 # would normally be skipped.
1669 my $topdir=abs_path(".")."/";
1670 my @repo=($topdir, $topdir, ".");
1671 loadconfig($tmpconfig, $topdir, $url);
1672 record(\@repo, action("checkout", @repo, 1))
1673 if exists $config{$topdir}{"."}{"checkout"};
1675 if (-e ".mrconfig") {
1676 print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $url\n";
1679 eval q{use File::Copy};
1681 move($tmpconfig, ".mrconfig") || die "rename: $!";
1684 # Reload the config file (in case we got a different version)
1685 # and checkout everything else.
1687 loadconfig(".mrconfig");
1688 dispatch("checkout");
1689 @skipped=grep { abs_path($_) ne abs_path($topdir) } @skipped;
1690 showstats("bootstrap");
1694 # alias expansion and command stemming
1697 if (exists $alias{$action}) {
1698 $action=$alias{$action};
1700 if (! exists $knownactions{$action}) {
1701 my @matches = grep { /^\Q$action\E/ }
1702 keys %knownactions, keys %alias;
1703 if (@matches == 1) {
1704 $action=$matches[0];
1706 elsif (@matches == 0) {
1707 die "mr: unknown action \"$action\" (known actions: ".
1708 join(", ", sort keys %knownactions).")\n";
1711 die "mr: ambiguous action \"$action\" (matches: ".
1712 join(", ", @matches).")\n";
1720 while (length $dir) {
1721 if (-e "$dir/.mrconfig") {
1722 return "$dir/.mrconfig";
1724 $dir=~s/\/[^\/]*$//;
1726 return $HOME_MR_CONFIG;
1731 Getopt::Long::Configure("bundling", "no_permute");
1732 my $result=GetOptions(
1733 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1734 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1735 "p|path" => sub { }, # now default, ignore
1736 "f|force" => \$force,
1737 "v|verbose" => \$verbose,
1738 "q|quiet" => \$quiet,
1739 "s|stats" => \$stats,
1740 "k|insecure" => \$insecure,
1741 "i|interactive" => \$interactive,
1742 "n|no-recurse:i" => \$max_depth,
1743 "j|jobs:i" => \$jobs,
1744 "t|trust-all" => \$trust_all,
1746 if (! $result || @ARGV < 1) {
1747 die("Usage: mr [options] action [params ...]\n".
1748 "(Use mr help for man page.)\n");
1751 $ENV{MR_SWITCHES}="";
1752 foreach my $option (@saved) {
1753 last if $option eq $ARGV[0];
1754 $ENV{MR_SWITCHES}.="$option ";
1760 print STDERR "mr: interrupted\n";
1764 # This can happen if it's run in a directory that was removed
1765 # or other strangeness.
1766 if (! defined $directory) {
1767 die("mr: failed to determine working directory\n");
1769 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1770 # the config file might be a symlink to elsewhere, and the directory it's
1771 # in is significant.
1772 if ($ENV{MR_CONFIG} !~ /^\//) {
1773 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1775 # Try to set MR_PATH to the path to the program.
1777 use FindBin qw($Bin $Script);
1778 $ENV{MR_PATH}=$Bin."/".$Script;
1796 loadconfig($HOME_MR_CONFIG);
1797 loadconfig($ENV{MR_CONFIG});
1798 #use Data::Dumper; print Dumper(\%config);
1800 my $action=expandaction(shift @ARGV);
1807 # Finally, some useful actions that mr knows about by default.
1808 # These can be overridden in ~/.mrconfig.
1823 echo "mr (warning): $@" >&2
1829 if [ -z "$1" ] || [ -z "$2" ]; then
1830 error "mr: usage: hours_since action num"
1832 for dir in .git .svn .bzr CVS .hg _darcs _FOSSIL_; do
1833 if [ -e "$MR_REPO/$dir" ]; then
1834 flagfile="$MR_REPO/$dir/.mr_last$1"
1838 if [ -z "$flagfile" ]; then
1839 error "cannot determine flag filename"
1841 delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
1842 if [ "$delta" -lt "$2" ]; then
1850 LANG=C bzr info | egrep -q '^Checkout'
1853 if [ -d "$MR_REPO" ]; then
1860 svn_test = perl: -d "$ENV{MR_REPO}/.svn"
1861 git_test = perl: -d "$ENV{MR_REPO}/.git"
1862 bzr_test = perl: -d "$ENV{MR_REPO}/.bzr"
1863 cvs_test = perl: -d "$ENV{MR_REPO}/CVS"
1864 hg_test = perl: -d "$ENV{MR_REPO}/.hg"
1865 darcs_test = perl: -d "$ENV{MR_REPO}/_darcs"
1866 fossil_test = perl: -f "$ENV{MR_REPO}/_FOSSIL_"
1867 git_bare_test = perl:
1868 -d "$ENV{MR_REPO}/refs/heads" && -d "$ENV{MR_REPO}/refs/tags" &&
1869 -d "$ENV{MR_REPO}/objects" && -f "$ENV{MR_REPO}/config" &&
1870 `GIT_CONFIG="$ENV{MR_REPO}"/config git config --get core.bare` =~ /true/
1871 veracity_test = perl: -d "$ENV{MR_REPO}/.sgdrawer"
1873 svn_update = svn update "$@"
1874 git_update = git pull "$@"
1876 if is_bzr_checkout; then
1879 bzr merge --pull "$@"
1881 cvs_update = cvs update "$@"
1882 hg_update = hg pull "$@" && hg update "$@"
1883 darcs_update = darcs pull -a "$@"
1884 fossil_update = fossil pull "$@"
1885 veracity_update = vv pull "$@" && vv update "$@"
1887 svn_status = svn status "$@"
1888 git_status = git status -s "$@" || true
1889 bzr_status = bzr status --short "$@"
1890 cvs_status = cvs status "$@"
1891 hg_status = hg status "$@"
1892 darcs_status = darcs whatsnew -ls "$@" || true
1893 fossil_status = fossil changes "$@"
1894 veracity_status = vv status "$@"
1896 svn_commit = svn commit "$@"
1897 git_commit = git commit -a "$@" && git push --all
1899 if is_bzr_checkout; then
1902 bzr commit "$@" && bzr push
1904 cvs_commit = cvs commit "$@"
1905 hg_commit = hg commit -m "$@" && hg push
1906 darcs_commit = darcs record -a -m "$@" && darcs push -a
1907 fossil_commit = fossil commit "$@"
1908 veracity_commit = vv commit -m "@"
1910 git_record = git commit -a "$@"
1912 if is_bzr_checkout; then
1913 bzr commit --local "$@"
1917 hg_record = hg commit -m "$@"
1918 darcs_record = darcs record -a -m "$@"
1919 fossil_record = fossil commit "$@"
1920 veracity_record = vv commit -m "@"
1923 git_push = git push "$@"
1924 bzr_push = bzr push "$@"
1926 hg_push = hg push "$@"
1927 darcs_push = darcs push -a "$@"
1928 fossil_push = fossil push "$@"
1929 veracity_push = vv push "$@"
1931 svn_diff = svn diff "$@"
1932 git_diff = git diff "$@"
1933 bzr_diff = bzr diff "$@"
1934 cvs_diff = cvs diff "$@"
1935 hg_diff = hg diff "$@"
1936 darcs_diff = darcs diff -u "$@"
1937 fossil_diff = fossil diff "$@"
1938 veracity_diff = vv diff "$@"
1940 svn_log = svn log "$@"
1941 git_log = git log "$@"
1942 bzr_log = bzr log "$@"
1943 cvs_log = cvs log "$@"
1944 hg_log = hg log "$@"
1945 darcs_log = darcs changes "$@"
1946 git_bare_log = git log "$@"
1947 fossil_log = fossil timeline "$@"
1948 veracity_log = vv log "$@"
1953 url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
1954 if [ -z "$url" ]; then
1955 error "cannot determine svn url"
1957 echo "Registering svn url: $url in $MR_CONFIG"
1958 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1960 url="`LC_ALL=C git config --get remote.origin.url`" || true
1961 if [ -z "$url" ]; then
1962 error "cannot determine git url"
1964 echo "Registering git url: $url in $MR_CONFIG"
1965 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1967 url="`LC_ALL=C bzr info . | egrep -i 'checkout of branch|parent branch' | awk '{print $NF}'`"
1968 if [ -z "$url" ]; then
1969 error "cannot determine bzr url"
1971 echo "Registering bzr url: $url in $MR_CONFIG"
1972 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr branch '$url' '$MR_REPO'"
1974 repo=`cat CVS/Repository`
1976 if [ -z "$root" ]; then
1977 error "cannot determine cvs root"
1979 echo "Registering cvs repository $repo at root $root"
1980 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1982 url=`hg showconfig paths.default`
1983 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1984 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1986 url=`cat _darcs/prefs/defaultrepo`
1987 echo "Registering darcs repository $url in $MR_CONFIG"
1988 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url' '$MR_REPO'"
1990 url="`LC_ALL=C GIT_CONFIG=config git config --get remote.origin.url`" || true
1991 if [ -z "$url" ]; then
1992 error "cannot determine git url"
1994 echo "Registering git url: $url in $MR_CONFIG"
1995 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1997 url=`fossil remote-url`
1998 repo=`fossil info | grep repository | sed -e 's/repository:*.//g' -e 's/ //g'`
1999 echo "Registering fossil repository $url in $MR_CONFIG"
2000 mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && fossil open '$repo'"
2002 url=`vv config | grep sync_targets | sed -e 's/sync_targets:*.//g' -e 's/ //g'`
2003 repo=`vv repo info | grep repository | sed -e 's/Current repository:*.//g' -e 's/ //g'`
2004 echo "Registering veracity repository $url in $MR_CONFIG"
2005 mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && vv checkout '$repo'"
2007 svn_trusted_checkout = svn co $url $repo
2008 svn_alt_trusted_checkout = svn checkout $url $repo
2009 git_trusted_checkout = git clone $url $repo
2010 bzr_trusted_checkout = bzr checkout|clone|branch|get $url $repo
2012 hg_trusted_checkout = hg clone $url $repo
2013 darcs_trusted_checkout = darcs get $url $repo
2014 git_bare_trusted_checkout = git clone --bare $url $repo
2015 # fossil: messy to do
2016 veracity_trusted_checkout = vv clone $url $repo
2022 SHOWMANFILE="man -f"
2028 SHOWMANFILE="man -l"
2031 if [ ! -e "$MR_PATH" ]; then
2032 error "cannot find program path"
2034 tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
2035 trap "rm -f $tmp" exit
2036 pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
2037 $SHOWMANFILE "$tmp" || error "man failed"
2043 if [ -s ~/.mrlog ]; then
2044 info "running offline commands"
2045 mv -f ~/.mrlog ~/.mrlog.old
2046 if ! sh -e ~/.mrlog.old; then
2047 error "offline command failed; left in ~/.mrlog.old"
2051 info "no offline commands to run"
2056 info "offline mode enabled"
2058 info "remembering command: 'mr $@'"
2059 command="mr -d '$(pwd)' $MR_SWITCHES"
2061 command="$command '$w'"
2063 if [ ! -e ~/.mrlog ] || ! grep -q -F "$command" ~/.mrlog; then
2064 echo "$command" >> ~/.mrlog
2067 ed = echo "A horse is a horse, of course, of course.."
2068 T = echo "I pity the fool."
2069 right = echo "Not found."
2071 # vim:sw=8:sts=0:ts=8:noet
2073 # indent-tabs-mode: t
2074 # cperl-indent-level: 8